//filename: main.cpp

#include <windows.h>
#include <stdlib.h>
#include <wtypes.h>
#include <conio.h>
#include <stdio.h>
#include "main.h"


BOOLEAN LoadLibraries()
{
	hLib30x = LoadLibrary ("LL_USB.dll");
    if(!hLib30x) return FALSE;
    return TRUE;
}

BOOLEAN InitLibFuncs()
{  
	EX_Connect = (P_DLL_EX_CONNECT)GetProcAddress(hLib30x, "EX_Connect");
	if(!EX_Connect) return FALSE;
	EX_SetPolledModeChan = (P_DLL_EX_SET_CHAN)GetProcAddress(hLib30x, "EX_SetPolledModeChan");
	if(!EX_SetPolledModeChan) return FALSE;
	EX_GetOneConversion = (P_DLL_EX_GET_ONE_CONVERSION)GetProcAddress(hLib30x, "EX_GetOneConversion");
	if(!EX_GetOneConversion) return FALSE;
	EX_Run = (P_DLL_EX_RUN)GetProcAddress(hLib30x, "EX_Run");
	if(!EX_Run) return FALSE;
	EX_Stop = (P_DLL_EX_STOP)GetProcAddress(hLib30x, "EX_Stop");
	if(!EX_Stop) return FALSE;
	EX_StopComplete = (P_DLL_EX_STOP_COMPLETE)GetProcAddress(hLib30x, "EX_StopComplete");
	if(!EX_StopComplete) return FALSE;
	EX_SendDigout = (P_DLL_EX_SEND_DIGOUT)GetProcAddress(hLib30x, "EX_SendDigout");
	if(!EX_SendDigout) return FALSE;
	EX_GetDigin = (P_DLL_EX_GET_DIGIN)GetProcAddress(hLib30x, "EX_GetDigin");
	if(!EX_GetDigin) return FALSE;

    return TRUE;
}


int __cdecl main()
{
	USHORT usDevID = 0; BYTE bDigIn; double dblMillivolts;
	BOOLEAN fRetVal = FALSE; BOOLEAN fRunning = FALSE; BOOLEAN fRedraw = FALSE;

	if(!LoadLibraries()){ printf("Failed to load libraries"); getch(); return 0;}
	printf("Success loading libraries\n");

	if(!InitLibFuncs())
	{ printf("Failed to find required functions"); getch(); return 0;}

	printf("Success finding required functions\nConnecting -  please wait. . .");
	fRetVal = EX_Connect(&usDevID);
	if(!(fRetVal | usDevID))
	{ printf("Failed  EX_Connect()"); getch(); return 0; }

	char cUserInputVal = NULL; char szOutVal[32], szTempBuff[32]; int iKeyChar = 0;  

	while(true)
	{
		setMainScreen();
		fRedraw = FALSE;

		while((cUserInputVal != 'Q') && (cUserInputVal != 'q') && (cUserInputVal != 27) && (!fRedraw))
		{
			sprintf(szOutVal, ""); 
			cUserInputVal = (char)getch();
			switch(cUserInputVal)
			{
				case 'Q': case 'q': case 27:
					printf("\nDisconnecting and exiting, please wait ....\n"); break;
				case 'R': case 'r':
					fRedraw = TRUE; system("cls"); break;
				case 'C': case 'c':
					printf("\nenter channel: ");
					while(TRUE)
					{
						iKeyChar = getche(); if(iKeyChar == 13) break;
						// take care of backspaces and non-numerics
						if(((iKeyChar == 8) || (iKeyChar < 48) || (iKeyChar > 57))) 
						{
							setMainScreen(); 
							 if( (strlen(szOutVal) > 0) && (iKeyChar == 8)) szOutVal[strlen(szOutVal)-1] = 0; 
							printf("\nenter channel: %s", szOutVal);
							continue;
						}
						sprintf(szTempBuff, "%u", ((BYTE)iKeyChar) - '0');
						strcat(szOutVal, szTempBuff); if(strlen(szOutVal) == 1) break;
					}
					
					if(((UINT)(atoi(szOutVal))) > 7)
					{ printf("\nvalue entered greater than 7. New value: 7"); sprintf(szOutVal, "7"); }
					
					if(!EX_SetPolledModeChan(usDevID, (BYTE)(atoi(szOutVal)))) printf("\nfailed to send channel\n"); 
					else printf("\nchannel sent: %d\n", (BYTE)(atoi(szOutVal)));
					sprintf(szOutVal, ""); break;
				case 'V': case 'v':
					if(fRunning) { printf("Not while scanning. Press 'E' to end scan first.\n"); break; }
					if(!EX_GetOneConversion(usDevID, &dblMillivolts)) printf("\nfailed to get voltage\n"); 
					else(printf("voltage: %2.6lf\n", dblMillivolts / 1000.0)); break;
				case 'S': case 's':
					if(!fRunning)
					{
						if(!EX_Run(usDevID)) printf("\nfailed to start scan run\n"); 
						else
						{ printf("\nScan running. Data being logged to disk file\n\tPress 'E' to end run\n"); fRunning = TRUE; }
					}
					else printf("Already running - Press 'E' to stop\n"); break;
				case 'E': case 'e':
					if(fRunning)
					{
						if(!EX_Stop(usDevID)) printf("\nfailed to stop scan run\n"); 
						else
						{ EX_StopComplete(usDevID); printf("\nScan Stopped.\n"); fRunning = FALSE; }
					}
					else printf("Already Stopped - Press 'S' to start scan run\n"); break;
				case 'O': case 'o':
					sprintf(szOutVal, ""); printf("\nenter digital output value: ");
					while(TRUE)
					{
						// take care of backspaces and non-numerics
						if(((iKeyChar == 8) || (iKeyChar < 48) || (iKeyChar > 57)) && (strlen(szOutVal) > 0)) 
						{
							setMainScreen(); if(iKeyChar == 8) szOutVal[strlen(szOutVal)-1] = 0; 
							printf("\nenter digital output value: %s", szOutVal);
							continue;
						}
						iKeyChar = getche(); if(iKeyChar == 13) break;
						sprintf(szTempBuff, "%u", ((BYTE)iKeyChar) - '0');
						strcat(szOutVal, szTempBuff); if(strlen(szOutVal) == 3) break;
					}
					
					if(((UINT)(atoi(szOutVal))) > 255)
					{ printf("\nvalue entered greater than 255. New value: 255"); sprintf(szOutVal, "255"); }
					
					if(!EX_SendDigout(usDevID, (BYTE)(atoi(szOutVal)))) printf("\nfailed to send digital output\n"); 
					else printf("\ndigital output sent: %d\n", (BYTE)(atoi(szOutVal)));
					sprintf(szOutVal, ""); break;
				case 'I': case 'i':
					if(!EX_GetDigin(usDevID, &bDigIn)) printf("\nfailed to get digital input\n"); 
					else(printf("digital input: %d\n", bDigIn)); break;
			}
		}
		if(!fRedraw) break;
	}

	return 1;
}
void setMainScreen(void)
{
	system("cls");
	printf("\nINITIALIZED\nPress one of the following keys:\n"
		"'Q' quit\n"
		"'R' redraw screen\n"
		"'C' set the channel\n"
		"'V' get one voltage -   ( reads from current channel )\n"
		"'S' start scanning\n"
		"'E' end scanning\n"
		"'O' send digital output (follow by value 255 or less)\n"
		"'I' get digital input\n"
		);
}

